Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Interface Table<R,C,V>

Type Parameters:
  `R` - the type of the table row keys
  `C` - the type of the table column keys
  `V` - the type of the mapped values

All Known Subinterfaces:
  RowSortedTable<R,C,V>

All Known Implementing Classes:
  ArrayTable, ForwardingTable, HashBasedTable, TreeBasedTable

    @GwtCompatible
    @Beta
    public interface Table<R,C,V>

A collection that associates an ordered pair of keys, called a row key and a column key, with a single value. A table may be sparse, with only a small fraction of row key / column key pairs possessing a corresponding value.

The mappings corresponding to a given row key may be viewed as a `Map` whose keys are the columns. The reverse is also available, associating a column with a row key / value map. Note that, in some implementations, data access by column key may have fewer supported operations or worse performance than data access by row key.

The methods returning collections or maps always return views of the underlying table. Updating the table can change the contents of those collections, and updating the collections will change the table.

All methods that modify the table are optional, and the views returned by the table may or may not be modifiable. When modification isn't supported, those methods will throw an `UnsupportedOperationException`.

Since:
  7.0
Author:
  Jared Levy

Nested Class Summary
`static interface` | `Table.Cell<R,C,V>` Row key / column key / value triplet corresponding to a mapping in a table.

Method Summary
`Set<Table.Cell<R,C,V>>` | `cellSet()` Returns a set of all row key / column key / value triplets.
`void` | `clear()` Removes all mappings from the table.
`Map<R,V>` | `column(C columnKey)` Returns a view of all mappings that have the given column key.
`Set<C>` | `columnKeySet()` Returns a set of column keys that have one or more values in the table.
`Map<C,Map<R,V>>` | `columnMap()` Returns a view that associates each column key with the corresponding map from row keys to values.
`boolean` | `contains(Object rowKey, Object columnKey)` Returns `true` if the table contains a mapping with the specified row and column keys.
`boolean` | `containsColumn(Object columnKey)` Returns `true` if the table contains a mapping with the specified column.
`boolean` | `containsRow(Object rowKey)` Returns `true` if the table contains a mapping with the specified row key.
`boolean` | `containsValue(Object value)` Returns `true` if the table contains a mapping with the specified value.
`boolean` | `equals(Object obj)` Compares the specified object with this table for equality.
`V` | `get(Object rowKey, Object columnKey)` Returns the value corresponding to the given row and column keys, or `null` if no such mapping exists.
`int` | `hashCode()` Returns the hash code for this table.
`boolean` | `isEmpty()` Returns `true` if the table contains no mappings.
`V` | `put(R rowKey, C columnKey, V value)` Associates the specified value with the specified keys.
`void` | `putAll(Table<? extends R,? extends C,? extends V> table)` Copies all mappings from the specified table to this table.
`V` | `remove(Object rowKey, Object columnKey)` Removes the mapping, if any, associated with the given keys.
`Map<C,V>` | `row(R rowKey)` Returns a view of all mappings that have the given row key.
`Set<R>` | `rowKeySet()` Returns a set of row keys that have one or more values in the table.
`Map<R,Map<C,V>>` | `rowMap()` Returns a view that associates each row key with the corresponding map from column keys to values.
`int` | `size()` Returns the number of row key / column key / value mappings in the table.
`Collection<V>` | `values()` Returns a collection of all values, which may contain duplicates.

Method Detail

### contains

    boolean contains(@Nullable
                     Object rowKey,
                     @Nullable
                     Object columnKey)

  Returns `true` if the table contains a mapping with the specified row and column keys.

  Parameters:
    `rowKey` - key of row to search for
    `columnKey` - key of column to search for

### containsRow

    boolean containsRow(@Nullable
                        Object rowKey)

  Returns `true` if the table contains a mapping with the specified row key.

  Parameters:
    `rowKey` - key of row to search for

### containsColumn

    boolean containsColumn(@Nullable
                           Object columnKey)

  Returns `true` if the table contains a mapping with the specified column.

  Parameters:
    `columnKey` - key of column to search for

### containsValue

    boolean containsValue(@Nullable
                          Object value)

  Returns `true` if the table contains a mapping with the specified value.

  Parameters:
    `value` - value to search for

### get

    V get(@Nullable
          Object rowKey,
          @Nullable
          Object columnKey)

  Returns the value corresponding to the given row and column keys, or `null` if no such mapping exists.

  Parameters:
    `rowKey` - key of row to search for
    `columnKey` - key of column to search for

### isEmpty

    boolean isEmpty()

  Returns `true` if the table contains no mappings.

### size

    int size()

  Returns the number of row key / column key / value mappings in the table.

### equals

    boolean equals(@Nullable
                   Object obj)

  Compares the specified object with this table for equality. Two tables are equal when their cell views, as returned by `cellSet()`, are equal.

  Overrides:
    `equals` in class `Object`

### hashCode

    int hashCode()

  Returns the hash code for this table. The hash code of a table is defined as the hash code of its cell view, as returned by `cellSet()`.

  Overrides:
    `hashCode` in class `Object`

### clear

    void clear()

  Removes all mappings from the table.

### put

    V put(R rowKey,
          C columnKey,
          V value)

  Associates the specified value with the specified keys. If the table already contained a mapping for those keys, the old value is replaced with the specified value.

  Parameters:
    `rowKey` - row key that the value should be associated with
    `columnKey` - column key that the value should be associated with
    `value` - value to be associated with the specified keys
  Returns:
    the value previously associated with the keys, or `null` if no mapping existed for the keys

### putAll

    void putAll(Table<? extends R,? extends C,? extends V> table)

  Copies all mappings from the specified table to this table. The effect is equivalent to calling `put(R, C, V)` with each row key / column key / value mapping in `table`.

  Parameters:
    `table` - the table to add to this table

### remove

    V remove(@Nullable
             Object rowKey,
             @Nullable
             Object columnKey)

  Removes the mapping, if any, associated with the given keys.

  Parameters:
    `rowKey` - row key of mapping to be removed
    `columnKey` - column key of mapping to be removed
  Returns:
    the value previously associated with the keys, or `null` if no such value existed

### row

    Map<C,V> row(R rowKey)

  Returns a view of all mappings that have the given row key. For each row key / column key / value mapping in the table with that row key, the returned map associates the column key with the value. If no mappings in the table have the provided row key, an empty map is returned.

  Changes to the returned map will update the underlying table, and vice versa.

  Parameters:
    `rowKey` - key of row to search for in the table
  Returns:
    the corresponding map from column keys to values

### column

    Map<R,V> column(C columnKey)

  Returns a view of all mappings that have the given column key. For each row key / column key / value mapping in the table with that column key, the returned map associates the row key with the value. If no mappings in the table have the provided column key, an empty map is returned.

  Changes to the returned map will update the underlying table, and vice versa.

  Parameters:
    `columnKey` - key of column to search for in the table
  Returns:
    the corresponding map from row keys to values

### cellSet

    Set<Table.Cell<R,C,V>> cellSet()

  Returns a set of all row key / column key / value triplets. Changes to the returned set will update the underlying table, and vice versa. The cell set does not support the `add` or `addAll` methods.

  Returns:
    set of table cells consisting of row key / column key / value triplets

### rowKeySet

    Set<R> rowKeySet()

  Returns a set of row keys that have one or more values in the table. Changes to the set will update the underlying table, and vice versa.

  Returns:
    set of row keys

### columnKeySet

    Set<C> columnKeySet()

  Returns a set of column keys that have one or more values in the table. Changes to the set will update the underlying table, and vice versa.

  Returns:
    set of column keys

### values

    Collection<V> values()

  Returns a collection of all values, which may contain duplicates. Changes to the returned collection will update the underlying table, and vice versa.

  Returns:
    collection of values

### rowMap

    Map<R,Map<C,V>> rowMap()

  Returns a view that associates each row key with the corresponding map from column keys to values. Changes to the returned map will update this table. The returned map does not support `put()` or `putAll()`, or `setValue()` on its entries.

  In contrast, the maps returned by `rowMap().get()` have the same behavior as those returned by `row(R)`. Those maps may support `setValue()`, `put()`, and `putAll()`.

  Returns:
    a map view from each row key to a secondary map from column keys to values

### columnMap

    Map<C,Map<R,V>> columnMap()

  Returns a view that associates each column key with the corresponding map from row keys to values. Changes to the returned map will update this table. The returned map does not support `put()` or `putAll()`, or `setValue()` on its entries.

  In contrast, the maps returned by `columnMap().get()` have the same behavior as those returned by `column(C)`. Those maps may support `setValue()`, `put()`, and `putAll()`.

  Returns:
    a map view from each column key to a secondary map from row keys to values

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.